
#pragma once

#include "frc/smartdashboard/Smartdashboard.h"
#include "networktables/NetworkTable.h"
#include "networktables/NetworkTableInstance.h"
#include "networktables/NetworkTableEntry.h"
#include "networktables/NetworkTableValue.h"

#include "StateMachine.h"

namespace Rebels {


    enum LimelightLedState {
        Default,
        Off,
        Flashing,
        On,
    };

    enum LimelightCameraMode {
        VisionProcessing,
        DriverCamera,
    };

    class Limelight {

    public:
        static void SetLedState(LimelightLedState state) {
            nt::NetworkTableInstance::GetDefault().GetTable("limelight")->PutNumber("ledMode", state);
        }

        static LimelightLedState GetLedState() {
            return (LimelightLedState)(int)nt::NetworkTableInstance::GetDefault().GetTable("limelight")->GetNumber("ledMode", 0.0);
        }

        static void SetCamMode(LimelightCameraMode mode) {
            nt::NetworkTableInstance::GetDefault().GetTable("limelight")->PutNumber("camMode", mode);
        }

        static double GetTx() {
            return nt::NetworkTableInstance::GetDefault().GetTable("limelight")->GetNumber("tx", 0.0);
        }

        static double GetTy() {
            return nt::NetworkTableInstance::GetDefault().GetTable("limelight")->GetNumber("ty", 0.0);
        }

        static double GetTa() {
            return nt::NetworkTableInstance::GetDefault().GetTable("limelight")->GetNumber("ta", 0.0);
        }
        static double GetTs() {
            return nt::NetworkTableInstance::GetDefault().GetTable("limelight")->GetNumber("ts", 0.0);
        }

        static bool GetTv() {
            return nt::NetworkTableInstance::GetDefault().GetTable("limelight")->GetNumber("tv", 0.0) == 1 ? true : false;
        }

    private:
        Limelight();
        ~Limelight();

    };


}