#pragma once

#include "Constants.h"
#include "Settings.h"
#include "Drive.h"
#include "../AutonomousMode.h"

namespace Rebels {

  class AutoBasic : public AutonomousMode {
  public:
    AutoBasic() = default;
    virtual ~AutoBasic();
    virtual void Periodic() override;

  private:
    void Go();
    void Stop();
    void ReleaseDrive();

    int warmupTicks{ 0 };
    units::second_t driveStartedAt{ 0.0 };
    bool driving = false;
    bool done = false;

    static const constexpr std::string_view SystemName{ "AutoBasic" };
    std::unique_ptr<Drive> drive;
  };
} // namespace Rebels
