#pragma once

#include "Constants.h"
#include "Settings.h"
#include "Drive.h"
#include "PointGuard.h"
#include "../AutonomousMode.h"

namespace Rebels {

  class AutoShoot : public AutonomousMode {
  public:
    AutoShoot() = default;
    virtual ~AutoShoot();
    virtual void Periodic() override;

  private:
    void Go();
    void Stop();
    void ReleaseDrive();
    enum AutoState {
      IDLE,
      DRIVING,
      START_SHOOTING,
      SHOOTING,
      END
    };

    AutoState autoState = IDLE;

    int warmupTicks{ 0 };
    units::second_t driveStartedAt{ 0.0 };
    units::second_t shootStartedAt{ 0_s };
    bool shooting = false;
    bool driving = false;
    bool done = false;

    static const constexpr std::string_view SystemName{ "AutoShoot" };
    std::unique_ptr<Drive> drive;
  };
} // namespace Rebels
