#pragma once

#include <frc/smartdashboard/SendableChooser.h>
#include "AutonomousMode.h"

class Autonomous {
public:
  Autonomous();
  ~Autonomous() = default;

  // Periodic is called every tick only when in auto
  void Periodic();

  void Start();
  void Stop();
  bool IsRunning() const { return isRunning; }

private:
  void Init();

  bool isRunning{ false };
  std::unique_ptr<AutonomousMode> mode;

  frc::SendableChooser<std::string> autoChooser;

  const std::string AutoDoNothing = "Do Nothing";
  const std::string AutoModeBasic = "Basic";
  const std::string AutoModeShoot = "Shoot";
};
