#pragma once
#include <units/time.h>
#include <units/length.h>
#include <frc/PneumaticsModuleType.h>

// Features
#define ENABLE_DRIVE
#define ENABLE_SHIFTERS
#define ENABLE_COMPRESSOR
// #define ENABLE_IMU
// #define ENABLE_OPSTICK
#define ENABLE_INTAKE
#define ENABLE_FEEDER
#define ENABLE_SHOOTER
#define ENABLE_CLIMBER

static const constexpr units::second_t TIMEOUT = 20_ms;
static const constexpr units::inch_t DRIVE_WHEEL_BASE{ 28_in };
static const constexpr units::inch_t DRIVE_WHEEL_CIRCUMFERENCE{ 6.0_in * M_PI };
static const constexpr double DRIVE_HIGH_GEAR_FACTOR = 8.9;
static const constexpr double DRIVE_LOW_GEAR_FACTOR = 22.8;

static const constexpr int PRESSURE_SENSOR_ANALOG_ID = 3;

static const int LED_PWM_ID = 8;
static const int LED_LENGTH = 20;

#ifdef ENABLE_DRIVE
static const int DRIVE_LEFT_LEADER_ID = 1;
static const int DRIVE_LEFT_FOLLOWER_ID = 2;
static const int DRIVE_RIGHT_LEADER_ID = 3;
static const int DRIVE_RIGHT_FOLLOWER_ID = 4;
#ifdef ENABLE_SHIFTERS
static const frc::PneumaticsModuleType SHIFTER_MODULE_TYPE = frc::PneumaticsModuleType::CTREPCM;
static const int SHIFTER_FORWARD_PCM_ID = 0;
static const int SHIFTER_BACKWARD_PCM_ID = 1;
#endif // ENABLE_SHIFTERS
#endif // ENABLE_DRIVE

#ifdef ENABLE_COMPRESSOR
static const frc::PneumaticsModuleType COMPRESSOR_MODULE_TYPE = frc::PneumaticsModuleType::CTREPCM;
#endif

#ifdef ENABLE_IMU
static const int IMU_ID = -1;
#endif

#ifdef ENABLE_INTAKE
static const int INTAKE_FORWARD_PCM_ID = 5;
static const int INTAKE_BACKWARD_PCM_ID = 4;
static const int INTAKE_ROLLER_MOTOR_ID = 13;
#endif

#ifdef ENABLE_FEEDER
static const int FEEDER_STAGE2_MOTOR_ID = 10;
static const int FEEDER_STAGE1_RIGHT_MOTOR_ID = 12;
static const int FEEDER_STAGE1_LEFT_MOTOR_ID = 14;
static const int FEEDER_BEAM_BREAK_ID = 9;
#endif

#ifdef ENABLE_SHOOTER
static const int SHOOTER_STAGE1_MOTOR_ID = 15;
static const int SHOOTER_STAGE2_MOTOR_ID = 16;
#endif

#ifdef ENABLE_CLIMBER
static const int CLIMBER_MOTOR_ID = 11;
static const int CLIMBER_FORWARD_PCM_ID = 2;
static const int CLIMBER_BACKWARD_PCM_ID = 3;
#endif