// Copyright (c) FIRST and other WPILib contributors.
// Open Source Software; you can modify and/or share it under the terms of
// the WPILib BSD license file in the root directory of this project.

#pragma once

#include "BaseRobot.h"
#include "Constants.h"
#include "Compressor.h"
#include "PressureSensor.h"
#include "Autonomous.h"
#include "Teleop.h"

class Robot : public BaseRobot {
public:
  Robot();
  virtual ~Robot() = default;

  virtual void RobotInit() override;
  virtual void RobotPeriodic() override;
  virtual void EnabledInit() override;
  virtual void DisabledInit() override;
  virtual void DisabledPeriodic() override;
  virtual void AutonomousInit() override;
  virtual void AutonomousPeriodic() override;
  virtual void TeleopInit() override;
  virtual void TeleopPeriodic() override;

private:
  std::unique_ptr<Autonomous> autonomous;
  std::unique_ptr<Teleop> teleop;

  // watchdog for compressor subsystem
  std::unique_ptr<Rebels::Compressor> compressor;

  // pressure sensor
  Rebels::PressureSensor pressureSensor{ PRESSURE_SENSOR_ANALOG_ID };
};
